Attribute VB_Name = "MoveChooser"
Dim RandomAttack As Integer
Dim RandomEnemy As Integer

Public Sub HeroChoose()
    ChooseEnemy
    SetBestAttack
    If Hero.Health < Hero.HealthMax Then                        'if health isn't max, maybe cure
       'this means the enemies could kill him in two rounds, so he cures till he is safe for at least 1 round
        If ((HData.RemainingEnemies * HData.EnemiesBestStrength) * 2) >= Hero.Health Then
            If (HData.RemainingEnemies * HData.EnemiesBestStrength) > (Hero.Health + Hero.Magic) Then 'cure MIGHT not save him
                If HData.AttackStrength > HData.MagicStrength Then
                    HeroAttack
                Else
                    HeroMagic
                End If
            Else
                HeroCure        'cures because this will definetly save him
            End If
        ElseIf HData.AttackStrength = -1000 Then
            HeroAttack
        ElseIf HData.MagicStrength = -1000 Then
            HeroMagic
        ElseIf HData.AttackStrength > HData.MagicStrength Then
                HeroAttack
        Else
                HeroMagic
        End If
    ElseIf (HData.AttackStrength > -1000) And (HData.MagicStrength > -1000) Then
        'attempt at best case scenario kill all(if both attacks have been used)
        'this would mean the Hero could perform a 'one hit kill'
        If (HData.EnemyMaxHealth <= HData.BestAttack) Then
            If ((Factorial(HData.RemainingEnemies) * HData.EnemiesBestStrength) < Hero.Health) Then

            End If
        End If
    ElseIf HData.AttackStrength = -1000 Then                       'this will check attack strength
        HeroAttack                                              'and test it if it hasn't been used
    ElseIf HData.MagicStrength = -1000 Then                     'this tests magic strength
        HeroMagic                                               'tests it if it hasn't been used
    End If
    'Increments Hero move counter
    BattleStats.HeroMoves = BattleStats.HeroMoves + 1
End Sub

Public Sub EnemyChoose()
    Randomize
    RandomAttack = Int(2) * Rnd
    
    If RandomAttack = 0 Then RandomAttack = 1
    Select Case RandomAttack
        Case 1: EnemyAttack
        Case 2: EnemySuicide
    End Select
    'Increments Enemy move counter
    BattleStats.EnemyMoves = BattleStats.EnemyMoves + 1
End Sub

'****************************************************
'TWO FUNCTIONS FOR CHOOSING ENEMY(they work together)
Public Sub SetRandom()
    Randomize
    RandomEnemy = (Int(Settings.NumberEnemies - 1) * Rnd) + 1
    If Enemies(RandomEnemy).Active = False Then SetRandom
End Sub
Public Sub ChooseEnemy()
    'This function finds the weakest enemy, by attacking
    'the weakest first, more enemies will die, which will
    'make less attacks on the Hero
    Dim LowEnemy, LowHealth As Integer
    SetRandom
    LowEnemy = RandomEnemy                          'starts with random(for when all enemies are at same health)
    LowHealth = Enemies(1).HealthMax                'sets starting health health
    For X = 1 To BSettings.Settings.NumberEnemies   'loops through enemies
        If Enemies(X).Active Then                   'checks to see if its alive
            If Enemies(X).Health < LowHealth Then   'finds weakest
                LowHealth = Enemies(X).Health       'sets weakest
                LowEnemy = X                        'sets weakest
            End If
        End If
    Next X
    BattleStats.AttackEnemy = LowEnemy
End Sub

'This module is the key module in the ARITIFICIAL INTELLIGENCE
'aspect of my program.  Until now I have been trying to finish
'the display and functionality of the program.  As of now I am
'almost done with making the program run on its own.

'After I am done making the program run on its own this module
'will completly change.  Right now it chooses attacks & enemies
'randomly.  In the final version this is where the AI will come in.
'This module will have the code to choose what moves each character
'should use.  This will be finish for the final version on Dec. 14th.
